<div class='ptx__tax'>
  <app-loading *ngIf="isLoadingPage"></app-loading>
  <app-personal-information
    [isSubmitted]='isSubmitted'
    [form]='form'
    (getEmployee)='getListRelatives($event)'
    [isCheckEmployeeHasTaxNumber]="true"
    [functionCode]='functionCode'
  ></app-personal-information>
  <form nz-form [formGroup]="form" style="margin-top: 20px">
    <div nz-row [nzGutter]="[30,30]">
      <div nz-col nzXs="12" nzLg="12">
        <mb-select [mbDataSelects]="listRelatives"
                   formControlName="familyRelationshipId"
                   (mbEventSelect)="changeRelatives($event)"
                   [mbType]="isSubmitted && form.controls['familyRelationshipId'].errors ? 'error' : 'default'"
                   [mbShowError]="isSubmitted && form.controls['familyRelationshipId'].errors !== null"
                   [mbErrors]="form.controls['familyRelationshipId'].errors"
                   [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'personalTax.validate.required' | translate: {'param': 'personalTax.dependentRegisters.dependentName' | translate }}]"
                   mbPlaceholder="{{'personalTax.dependentRegisters.dependentName' | translate}}"
                   mbLabelText="{{'personalTax.dependentRegisters.dependentName' | translate}} <span class='label__required'>*</span>"
        ></mb-select>
      </div>
      <div nz-col nzXs="12" nzLg="12">
        <mb-date-picker
          formControlName="dateOfBirth"
          (ngModelChange)="changeDateOfBirth($event)"
          mbLabelText="{{'personalTax.dependentRegisters.dateOfBirth' | translate}}"
          mbPlaceholderText="{{'personalTax.dependentRegisters.dateOfBirth' | translate}}"
        ></mb-date-picker>
      </div>
      <div nz-col nzXs="12" nzLg="12" *ngIf="isDetail">
        <mb-input-text
          mbPlaceholderText="{{'personalTax.dependentRegisters.dependentAge' | translate}}"
          mbLabelText="{{'personalTax.dependentRegisters.dependentAge' | translate}}"
          formControlName="dependentAge"></mb-input-text>
      </div>
    </div>
    <div nz-row [nzGutter]="[30,30]">
      <div nz-col nzXs="24" nzLg="24" style="display: flex; align-items: center; margin: 15px 0">
        <nz-switch [nzDisabled]="isDisabledCheckIdNo" formControlName="isHaveIdNo" (ngModelChange)="checkIsIdNo($event)"></nz-switch>
        <span style="margin-left: 10px">{{'personalTax.dependentRegisters.haveIdNo' | translate}}</span>
      </div>
    </div>
    <div nz-row [nzGutter]="[30,30]">
      <ng-container *ngIf="form.controls.isHaveIdNo.value">
        <div nz-col nzXs="12" nzLg="12">
          <mb-input-text
            formControlName="taxNo"
            [mbMaxLength]="10"
            appNumberInput
            [mbType]="isSubmitted && form.controls['taxNo'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && form.controls['taxNo'].errors !== null"
            [mbErrors]="form.controls['taxNo'].errors"
            [mbErrorDefs]="[
              { errorName: 'required', errorDescription: 'personalTax.validate.required' | translate: {'param': 'personalTax.dependentRegisters.idNoOrTaxNo' | translate }},
              { errorName: 'minlength', errorDescription: 'personalTax.validate.taxNoError' | translate},
              { errorName: 'maxlength', errorDescription: 'personalTax.validate.taxNoError' | translate}
            ]"
            mbPlaceholderText="{{'personalTax.dependentRegisters.taxNo' | translate}}"
            mbLabelText="{{'personalTax.dependentRegisters.taxNo' | translate}}"></mb-input-text>
        </div>
        <div nz-col nzXs="12" nzLg="12">
          <mb-input-text
            formControlName="idNo"
            [mbMaxLength]="12"
            appNumberInput
            [mbType]="(isSubmitted && form.controls['idNo'].errors || form.errors?.onlyAccept9Or12Digit) ? 'error' : 'default'"
            [mbShowError]="(isSubmitted && (form.controls['idNo'].errors !== null || form.errors?.onlyAccept9Or12Digit !== null))"
            [mbErrors]="form.errors?.onlyAccept9Or12Digit ? form.errors : form.controls['idNo'].errors"
            [mbErrorDefs]="[
                { errorName: 'required', errorDescription: 'personalTax.dependentRegisters.requiredIdNo' | translate },
                { errorName: 'onlyAccept9Or12Digit', errorDescription: 'personalTax.validate.onlyAccept9Or12Digit' | translate: {'param': 'personalTax.dependentRegisters.idNo' | translate}}
            ]"
            mbPlaceholderText="{{'personalTax.dependentRegisters.idNo' | translate}}"
            mbLabelText="{{'personalTax.dependentRegisters.idNo' | translate}}"></mb-input-text>
        </div>
      </ng-container>
      <ng-container *ngIf="!form.controls.isHaveIdNo.value">
        <div nz-col nzXs="12" nzLg="12">
          <mb-input-text
            formControlName="codeNo"
            [mbMaxLength]="20"
            [mbType]="isSubmitted && form.controls['codeNo'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && form.controls['codeNo'].errors !== null"
            [mbErrors]="form.controls['codeNo'].errors"
            [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'personalTax.validate.required' | translate: {'param': 'personalTax.dependentRegisters.codeNo' | translate }}]"
            mbPlaceholderText="{{'personalTax.dependentRegisters.codeNo' | translate}}"
            mbLabelText="{{'personalTax.dependentRegisters.codeNo' | translate}} <span class='label__required'>*</span>"></mb-input-text>
        </div>
        <div nz-col nzXs="12" nzLg="12">
          <mb-input-text
            formControlName="bookNo"
            [mbMaxLength]="20"
            [mbType]="isSubmitted && form.controls['bookNo'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && form.controls['bookNo'].errors !== null"
            [mbErrors]="form.controls['bookNo'].errors"
            [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'personalTax.validate.required' | translate: {'param': 'personalTax.dependentRegisters.bookNo' | translate }}]"
            mbPlaceholderText="{{'personalTax.dependentRegisters.bookNoNote' | translate}}"
            mbLabelText="{{'personalTax.dependentRegisters.bookNo' | translate}} <span class='label__required'>*</span>"></mb-input-text>
        </div>
        <div nz-col nzXs="12" nzLg="12">
          <mb-select [mbDataSelects]="nations"
                     formControlName="nationCode"
                     [mbType]="isSubmitted && form.controls['nationCode'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['nationCode'].errors !== null"
                     [mbErrors]="form.controls['nationCode'].errors"
                     [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'personalTax.validate.required' | translate: {'param': 'personalTax.dependentRegisters.nationCode' | translate }}]"
                     mbPlaceholder="{{'personalTax.dependentRegisters.nationCode' | translate}}"
                     mbLabelText="{{'personalTax.dependentRegisters.nationCode' | translate}} <span class='label__required'>*</span>"
          ></mb-select>
        </div>
        <div nz-col nzXs="12" nzLg="12">
          <mb-select [mbDataSelects]="provinces"
                     formControlName="provinceCode"
                     (mbEventEmit)="changeProvince($event)"
                     [mbType]="isSubmitted && form.controls['provinceCode'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['provinceCode'].errors !== null"
                     [mbErrors]="form.controls['provinceCode'].errors"
                     [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'personalTax.validate.required' | translate: {'param': 'personalTax.dependentRegisters.provinceCode' | translate }}]"
                     mbPlaceholder="{{'personalTax.dependentRegisters.provinceCode' | translate}}"
                     mbLabelText="{{'personalTax.dependentRegisters.provinceCode' | translate}} <span class='label__required'>*</span>"
          ></mb-select>
        </div>
        <div nz-col nzXs="12" nzLg="12">
          <mb-select [mbDataSelects]="districts"
                     formControlName="districtCode"
                     (mbEventEmit)="changeDistrict($event)"
                     [mbType]="isSubmitted && form.controls['districtCode'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['districtCode'].errors !== null"
                     [mbErrors]="form.controls['districtCode'].errors"
                     [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'personalTax.validate.required' | translate: {'param': 'personalTax.dependentRegisters.districtCode' | translate }}]"
                     mbPlaceholder="{{'personalTax.dependentRegisters.districtCode' | translate}}"
                     mbLabelText="{{'personalTax.dependentRegisters.districtCode' | translate}} <span class='label__required'>*</span>"
          ></mb-select>
        </div>
        <div nz-col nzXs="12" nzLg="12">
          <mb-select [mbDataSelects]="wards"
                     formControlName="wardCode"
                     [mbType]="isSubmitted && form.controls['wardCode'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['wardCode'].errors !== null"
                     [mbErrors]="form.controls['wardCode'].errors"
                     [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'personalTax.validate.required' | translate: {'param': 'personalTax.dependentRegisters.wardCode' | translate }}]"
                     mbPlaceholder="{{'personalTax.dependentRegisters.wardCode' | translate}}"
                     mbLabelText="{{'personalTax.dependentRegisters.wardCode' | translate}} <span class='label__required'>*</span>"
          ></mb-select>
        </div>
      </ng-container>
      <div nz-col nzXs="12" nzLg="12">
        <mb-date-picker
          mbPlaceholderText="{{'personalTax.dependentRegisters.fromDate' | translate}}"
          mbLabelText="{{'personalTax.dependentRegisters.fromDate' | translate}} <span class='label__required'>*</span>"
          mbMode="month"
          [mbFormat]="'MM/yyyy'"
          [mbType]="isSubmitted && (form.errors || form.controls['fromDate'].errors) ? 'error' : 'default'"
          [mbShowError]="isSubmitted && (form.errors || form.controls['fromDate'].errors ) !== null"
          [mbErrors]="form.errors?.rangeDateError ? form.errors : form.controls['fromDate'].errors"
          [mbErrorDefs]="[{ errorName: 'rangeDateError', errorDescription: 'personalTax.validate.rangeDate.pareDate' | translate:
        {'fromDate': 'personalTax.dependentRegisters.fromDate' | translate, 'toDate': 'personalTax.dependentRegisters.toDate' | translate}},
             { errorName: 'required', errorDescription: 'personalTax.validate.required' | translate: {'param': 'personalTax.dependentRegisters.fromDate' | translate }}
          ]"
          formControlName="fromDate"></mb-date-picker>
      </div>
      <div nz-col nzXs="12" nzLg="12">
        <mb-date-picker
          mbPlaceholderText="{{'personalTax.dependentRegisters.toDate' | translate}}"
          mbLabelText="{{'personalTax.dependentRegisters.toDate' | translate}}"
          mbMode="month"
          [mbFormat]="'MM/yyyy'"
          formControlName="toDate"></mb-date-picker>
      </div>
      <div nz-col nzXs=24 nzLg="24" *ngIf="isDetail && (status === constant.STATUS_OBJ.FINANCIAL_ACCOUNTANT_RETURN || status === constant.STATUS_OBJ.TAX_AUTHORITIES_RETURN)">
        <mb-input-text
          formControlName="rejectReason"
          [mbIsTextAre]="true"
          mbLabelText="{{'personalTax.taxRegisters.rejectReason' | translate}}"></mb-input-text>
      </div>
      <div nz-col nzXs=24 nzLg="24">
        <mb-input-text
          formControlName="note"
          [mbIsTextAre]="true"
          [mbMaxLength]="500"
          mbPlaceholderText="{{'personalTax.dependentRegisters.note' | translate}}"
          mbLabelText="{{'personalTax.dependentRegisters.note' | translate}}"></mb-input-text>
      </div>
      <div nz-col nzXs='24' nzLg='20' class="input__group">
        <label class="input__label">{{'personalTax.label.attachFile' | translate}} <span class='label__required'>*</span></label>
        <span class="uploadHintText">{{'personalTax.taxRegisters.uploadHintText' | translate}}</span>

        <div class="uploadFile--wrap">
          <nz-upload
            [nzMultiple]=" true"
            [(nzFileList)]="fileList"
            [nzBeforeUpload]="beforeUpload"
            [nzRemove]="removeFile"
            [nzDownload]="downloadFile"
            nzAccept=".TIF, .JPG, .GIF, .PNG, .PDF, .DOC, .DOCX, .XLS, .XLSX"
          >
            <button class="btnUploadFile">{{'personalTax.taxRegisters.btnUploadFile' | translate}}</button>
          </nz-upload>
        </div>

          <div *ngIf="isSubmitted && this.fileList?.length === 0" class="input__group">
              <div class="input__message">
                  <em nz-icon nzType="close-circle" nzTheme="outline"></em>
                  <span class="text__message">{{'personalTax.validate.fileRequired' | translate}}</span>
              </div>
          </div>

      </div>
      <div nz-col nzXs="24" nzLg="24" [ngStyle]="{'text-align': 'right'}" >
        <mb-button
          *ngIf="!isDetail"
          mbButtonSize='MEDIUM'
          mbButtonAvailableStyle='BtnCancelHasBorder'
          (click)="closeModalAdd()"
          mbButtonText="{{'personalTax.dependentRegisters.cancel' | translate}}"
        ></mb-button>
        <mb-button
          *ngIf="isDetail"
          mbButtonSize='MEDIUM'
          mbButtonAvailableStyle='BtnCancelHasBorder'
          (click)="closeModalAdd()"
          mbButtonText="{{'personalTax.dependentRegisters.back' | translate}}"
        ></mb-button>

        <mb-button mbButtonSize='MEDIUM' mbButtonAvailableStyle='PRIMARY'
                   (click)="save(constant.STATUS_OBJ.WAIT_APPROVE)"
                   *ngIf="!isDetail"
                   mbButtonText="{{'personalTax.dependentRegisters.save' | translate}}"></mb-button>

        <mb-button
          *ngIf="status && status === constant.STATUS_OBJ.WAIT_APPROVE && isDetail && objFunction?.approve"
          mbButtonSize='SMALL'
          mbButtonAvailableStyle='PRIMARY'
          mbButtonText="{{'personalTax.label.approve' | translate}}"
          (click)="approveById(registerId)"
        ></mb-button>
        <mb-button
          *ngIf="status && status === constant.STATUS_OBJ.WAIT_APPROVE && isDetail && objFunction?.approve"
          mbButtonSize='SMALL'
          mbButtonAvailableStyle='DEFAULT'
          (click)="openRejectForm()"
          mbButtonText="{{'personalTax.label.reject' | translate}}"
        ></mb-button>
      </div>
    </div>

    <app-reject-common
      [isReject]="isReject"
      [id]="registerId"
      [urlRejectByList]="urlReject"
      (onCloseModal)="doCloseReject($event)"
    >
    </app-reject-common>
  </form>
</div>
